var critical = null;
var low = null;
var orange = null;
var timeout = null;
var gauge = null;
var pctText = null;
var infoText = null;
var altcalc = null;
var MAXGAUGEWIDTH = 111;
var numbg;
var font = null;

var objWMIService = null;

var detectSetting = null;
var calculatedRT = -1; // calculated remaining time
var validTimePerPCT = -1;
var lastpct = -1;

var doingCalc = false;

var PCT = new Array(-1, -1, -1); // stores the last 3 percentage remaining values (pct values may not be continuous if the computer has been put into sleep mode and consumed battery power)
var timePCT = new Array(null, null, null); // stores the corresponding times at which pct values have been reached

var bgOpacity = null;
var nAnim = 10;
var nAnimPass = 1;

function startPCT()
{
    return (PCT[2] != -1 ? PCT[2] : PCT[1]);
}

function startPCTtime()
{
    return (timePCT[2] != null ? timePCT[2] : timePCT[1]);
}

function reinitCounters()
{
    PCT = new Array(-1, -1, -1); 
    timePCT = new Array(null, null, null);
}

//calculates Remaining Time
function calcRT()
{
    doingCalc = true;
    var currentPCT = System.Machine.PowerStatus.batteryPercentRemaining;
    
    if(PCT[0] == -1)
        PCT[0] = currentPCT;

    if(currentPCT > PCT[0]) // battery has been charged while computer was sleeping

    {
        reinitCounters();
    }
    else if(currentPCT < PCT[0]) // pct remaining has changed since the last time this function was executed
    {
        timePCT[2] = timePCT[1];
        timePCT[1] = timePCT[0];
        timePCT[0] = new Date();
        if(timePCT[1] != null)
        {
            PCT[2] = PCT[1];
            PCT[1] = PCT[0];
        }
        PCT[0] = currentPCT;
        
        if(PCT[0] < startPCT())
        {
            var timePerPCT= (timePCT[0] - startPCTtime())/1000 /(startPCT() - PCT[0]);
            var referenceTimePerPCT = timePerPCT;
            
            if(timePCT[2] != null)
                referenceTimePerPCT = (timePCT[1] - timePCT[2])/1000;
            else if(validTimePerPCT != -1)
                referenceTimePerPCT = validTimePerPCT;
            
            if((timePerPCT > referenceTimePerPCT * 2) && timePCT[2] != null)
            {
                //reinit counters because of bad calculation (due to computer having been put on sleep since the beginning of the calculation)
                reinitCounters();
            }
            else
            {
                validTimePerPCT = timePerPCT;
                System.Gadget.Settings.write("timeperpct", validTimePerPCT);
            }
        }
    }

    if(validTimePerPCT != -1)
    {
        calculatedRT = Math.floor(validTimePerPCT/60 * currentPCT);
    }

    if(!System.Machine.PowerStatus.isPowerLineConnected)
        setTimeout("calcRT()", 5000);
    else
    {
        reinitCounters();
        doingCalc = false;
    }
}


function animate()
{
    if(nAnim < 20)
    {
        setTimeout("animate()", 50);
        nAnim++;
        gauge.opacity = Math.abs(nAnim - 10) * 10;
        return;
    }
    
    nAnim = 0;
    
    if(nAnimPass <1)
    {
        nAnimPass++;
        animate();
    }
    else
        nAnimPass = 0;
     
}


function init()
{
    detectSetting = ReadParam("detectSetting", true);
    LoadParams();

    if(!altcalc)
        objWMIService = GetObject("winmgmts:\\\\.\\root\\CIMV2");
        
    init2();
    
    System.Gadget.settingsUI = "Settings.html";
    System.Gadget.onSettingsClosed = SettingsClosed;

    updateDisplay();
    setTimeout("animate();",300);

}

function init2()
{
    bg.opacity = bgOpacity;
    gauge = bg.addImageObject("", 0, 4);
    gauge.opacity = 0;
    setGImageWidth(gauge, MAXGAUGEWIDTH, MAXGAUGEWIDTH, 4);
    bg.addImageObject("mask.png", 0, 0);
    
    var ypos = 0;
    var size = 24;
    switch(font)
    {
        case "Impact":
            ypos = 2;
            break;
        case "Candara":
            ypos = -1;
            size = 26;
            break;        
        case "Trebuchet MS":
            ypos = 3;
            break;
    }
    pctText = bg.addTextObject("", font, size, "Color(255,220,220,220)", 30, ypos);
    pctText.addGlow("Color(255,20,30,40)", 2, 30);
    
    infoText = bg.addTextObject("", "Segoe UI", 12, "Color(255,60,65,60)", 35, 26);
    infoText.addGlow("White", 2, 30);
}

function setGImageWidth(obj, newWidth, originalWidth, leftPos)
{
    obj.width = newWidth;
    //there is a bug in vista rtm's sidebar that occurs when scaling g:image objects. this function applies a workaround for correct positioning
    //if the bug is fixed (maybe in vista sp1?) the gadget will look bad until the following line is removed:
    obj.left = leftPos - (originalWidth - newWidth) / 2;
}

function setTextValue(obj, newText)
{
    obj.value = newText;
    //workaround for text bounds not resizing automatically when text changes
    obj.width = 0;
    obj.height = 0;
    //center text
    obj.left = 4 + (55 - obj.width/2);
}

function LaunchPowerApplet()
{
    System.Shell.execute(System.Environment.getEnvironmentVariable("SystemRoot") + "\\System32\\mblctr.exe", "/open");
}

function updateDisplay()
{
    clearTimeout(timeout);
    timeout = setTimeout("updateDisplay()", 10000);
    
    var pctRemaining = System.Machine.PowerStatus.batteryPercentRemaining;
    
    if(lastpct != -1 && !System.Machine.PowerStatus.isPowerLineConnected && lastpct != pctRemaining)
    {
        if((pctRemaining < low? (pctRemaining>critical?pctRemaining%2:0) : pctRemaining%10) == 0)
            setTimeout("animate();",600);

        if(pctRemaining <= critical)
            System.Sound.playSound(System.Environment.getEnvironmentVariable("SystemRoot") + "\\Media\\Windows Battery Critical.wav");
    }
    
    lastpct = pctRemaining;

    if(pctRemaining == 255) // no battery
    {
        setTextValue(infoText, text[5]);
        setTextValue(pctText, "--");
        gauge.opacity = 0;
        return;
    }
    else if(!System.Machine.PowerStatus.isPowerLineConnected)//running on battery
    {    
        var remaining = 0;
        if(!altcalc && !detectSetting)
        {
            remaining = getRemainingTime();
        }
        else if(altcalc) //alternative calculation explicitly set
        {
            if(!doingCalc)
            {
                reinitCounters();
                calcRT();
            }
            remaining = calculatedRT;
        }
        else //not yet sure which calculation method to use
        {
            remaining = getRemainingTime();
            if((remaining == 0 && pctRemaining > 0) || remaining == -1 || remaining == 71582788 || remaining == null)
            {
                if(!doingCalc)
                {
                    reinitCounters();
                    calcRT();
                }
                remaining = calculatedRT;
                
                if(startPCTtime()!=null && (timePCT[0] - startPCTtime()> 60000))
                {
                    altcalc = true;
                    detectSetting = false;
                    System.Gadget.Settings.write("detectSetting", false);
                    System.Gadget.Settings.write("altcalc", true);
                }
            }
            else //valid remaining time retrieved
            {
                detectSetting = false;
                System.Gadget.Settings.write("detectSetting", false);
            }
        }

        var hRemaining = Math.floor(remaining / 60);
        var mRemaining = remaining % 60;

        if(remaining != 71582788 && remaining != -1)
            setTextValue(infoText, hRemaining + ":" + padnumber(mRemaining) + " " + text[2]);
        else //no estimation available yet
        {
            if(infoText.value != text[6])
                setTextValue(infoText, text[6]);
            else
                setTextValue(infoText, text[16]);
        }
    }
    else if(System.Machine.PowerStatus.isBatteryCharging)
    {
        setTextValue(infoText, text[1]); //Charging
    }
    else
    {
        setTextValue(infoText, text[0]); //Fully charged
    }

    if(System.Machine.PowerStatus.isPowerLineConnected)
    {
        gauge.src = "gauge-g2.png";
    }
    else if(pctRemaining < critical || (pctRemaining < low && orange))
    {
        gauge.src = "gauge-r.png";
    }
    else if(pctRemaining < low)
    {
        gauge.src = "gauge-o.png";
    }
    else // running on batteries, but % remaining is still greater than "low"
    {
        if(orange)
            gauge.src = "gauge-o.png";
        else
            gauge.src = "gauge-g.png";
    }

    setGImageWidth(gauge, pctRemaining * MAXGAUGEWIDTH / 100, MAXGAUGEWIDTH, 4);
    setTextValue(pctText, " " + pctRemaining + "%");
}

function padnumber(num)
{
    if(num < 10)
        return "0"+num;
    else
        return num;    
}

function SettingsClosed() 
{
    LoadParams();
    bg.removeObjects();
    init2();
    nAnim=10;
    nAnimPass=1;
    setTimeout("animate();",300);
    updateDisplay();
}

function LoadParams()
{
    low = ReadParam("low", 20);
    critical = ReadParam("critical", 8);
    numbg = ReadParam("numbg", 2);
    bg.src = "bg"+ numbg +".png";
    altcalc = ReadParam("altcalc", false);
    orange = ReadParam("orange", true);
    font = ReadParam("font", "Raavi");
    validTimePerPCT = ReadParam("timeperpct", -1);    
    bgOpacity = ReadParam("bgOpacity", "100");
    System.Machine.PowerStatus.powerLineStatusChanged = updateDisplay;
}

function ReadParam(paramname, defaultvalue)
{
    var ret = System.Gadget.Settings.read(paramname);
    if(ret === "")
    {
        ret = defaultvalue;
        System.Gadget.Settings.write(paramname, defaultvalue);
    }
    return ret;
}

function getRemainingTime()
{
    var colItems = objWMIService.ExecQuery("SELECT * FROM Win32_Battery","WQL",48);
    var e = new Enumerator(colItems);
    if(!e.atEnd())
        return e.item().EstimatedRunTime;
    return -1;
}
